#include <iostream>
#include <list>
#include <algorithm>
#include "PRINT.h"
using namespace std;

int main()
{
    list<int> menge;

    /* Elemente 6 bis 1 gefolgt von 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_front(i);
        menge.push_back(i);
    }

    PRINT ("menge: ", menge);

    /* erstes Element mit Wert 4 finden
     */
    list<int>::iterator p1;
    p1 = find (menge.begin(), menge.end(), 4);

    /* letztes Element mit Wert 4 finden
     */
    list<int>::reverse_iterator p2;
    p2 = find (menge.rbegin(), menge.rend(), 4);

    /* Elemente von 4 bis 4 ausgeben
     *  - base() liefert Iterator zu Reverse-Iterator,
     *    der automatisch hinter dem aktuellen Objekt steht
     */
    cout << "von erster 4 bis letzter 4: ";
    copy (p1, p2.base(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
