#include <iostream>
#include <list>
#include <algorithm>
#include <functional>
using namespace std;

bool jedesDritte (int elem)
{
    static int anzahl = 0;

    anzahl++;
    if (anzahl == 3) {
        anzahl = 0;
        return true;
    }
    else {
        return false;
    }
}

int main()
{
    list<int> menge;

    /* Elemente 6 bis 1 und 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_front(i);    // vorne absteigend
        menge.push_back(i);     // hinten aufsteigend
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Menge ausgeben, wobei der Wert 3 jeweils durch 7 ersetzt wird
     */
    replace_copy (menge.begin(), menge.end(),
                  ostream_iterator<int>(cout," "),
                  3, 7);
    cout << endl;

    /* Menge ausgeben, wobei Werte groesser 4 durch 8 ersetzt werden
     */
    replace_copy_if (menge.begin(), menge.end(),
                     ostream_iterator<int>(cout," "),
                     bind2nd(greater<int>(),4), 8);
    cout << endl;

    /* Menge ausgeben, wobei jedes dritte Element 0 wird
     */
    replace_copy_if (menge.begin(), menge.end(),
                     ostream_iterator<int>(cout," "),
                     jedesDritte, 0);
    cout << endl;
}
