#include <iostream>
#include <deque>
#include <algorithm>
using namespace std;

void print (int elem)
{
    cout << elem << ' ';
}

int main()
{
    deque<int> menge;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* Iterator fuer die Position der 2 finden
     */
    deque<int>::iterator pos1;
    pos1 = find (menge.begin(), menge.end(), 2);

    /* Iterator fuer die Position der 5 finden
     */
    deque<int>::iterator pos2;
    pos2 = find (menge.begin(), menge.end(), 5);

    /* alle Elemente im Bereich [2,5) ausgeben
     */
    for_each (pos1, pos2, print);
    cout << endl;

    /* Iteratoren in Reverse-Iteratoren umwandeln
     */
    deque<int>::reverse_iterator rpos1(pos1);
    deque<int>::reverse_iterator rpos2(pos2);

    /* alle Elemente im Bereich [2,5) umgekehrt ausgeben
     */
    for_each (rpos2, rpos1, print);
    cout << endl;
}
