class IntFolge {
  private:
    int* wertAdr; // Zeiger(!) auf den Wert
    int* anzAdr;  // Zeiger auf Anzahl der Besitzer

    // Zuweisung macht keinen Sinn
    void operator= (const IntFolge& f) {
    }
  public:
    /* Konstruktor
     *  - Zeiger mit Speicherplatz initialisieren
     */
    IntFolge (int startwert) 
      : wertAdr(new int(startwert)),
        anzAdr(new int(1)) {
    }

    /* Copy-Konstruktor
     *  - Zeiger kopieren
     *  - Anzahl Besitzer erhoehen
     */
    IntFolge (const IntFolge& f)
      : wertAdr(f.wertAdr),
        anzAdr(f.anzAdr) {
            ++(*anzAdr);
    }

    /* Destruktor
     *  - Anzahl Besitzer vermindern
     *  - Speicherplatz ggf. freigeben
     */
    ~IntFolge () {
        if (--(*anzAdr) == 0) {
            delete wertAdr;
            delete anzAdr;
        }
    }

    /* Funktionsaufruf
     *  - Wert inkrementieren
     */
    int operator() () {
        return (*wertAdr)++;
    }
};
