#include <iostream>
#include <deque>
#include <algorithm>
#include <numeric>
using namespace std;

int main()
{
    deque<int> menge;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* alle Differenzen zum Vorgaenger ausgeben
     */
    adjacent_difference (menge.begin(), menge.end(),
                         ostream_iterator<int>(cout," "));
    cout << endl;

    /* alle Summen mit dem Vorgaenger ausgeben
     */
    adjacent_difference (menge.begin(), menge.end(),
                         ostream_iterator<int>(cout," "),
                         plus<int>());
    cout << endl;

    /* alle Produkte mit dem Vorgaenger ausgeben
     *  - frueher "times" statt "multiplies"
     */
    adjacent_difference (menge.begin(), menge.end(),
                         ostream_iterator<int>(cout," "),
                         multiplies<int>());
    cout << endl;
}
