#include <iostream>
#include <deque>
#include <algorithm>
#include <cstdlib>
using namespace std;

bool absLess (int elem1, int elem2)
{
    return abs(elem1) < abs(elem2);
}

int main()
{
    deque<int> menge;

    /* Elemente 2 bis 8 und -3 bis 5 in die Menge einfuegen
     */
    for (int i=2; i<=8; i++) {
        menge.push_back(i);
    }
    for (int i=-3; i<=5; i++) {
        menge.push_back(i);
    }

    /* Mengen ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Minimum und Maximum ausgeben
     */
    cout << "Minimum: "
         << *min_element(menge.begin(),menge.end()) << endl;
    cout << "Maximum: "
         << *max_element(menge.begin(),menge.end()) << endl;

    /* Minimum und Maximum vom Absolut-Wert ausgeben
     */
    cout << "Minimum anhand Absolut-Wert: "
         << *min_element(menge.begin(),menge.end(),absLess) << endl;
    cout << "Maximum anhand Absolut-Wert: "
         << *max_element(menge.begin(),menge.end(),absLess) << endl;
}
