#include <iostream>
#include <deque>
#include <algorithm>
#include <functional>
using namespace std;

int main()
{
    deque<int> menge;

    /* Elemente 9 bis 1 und 1 bis 9 in die Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge.push_front(i);    // vorne absteigend
        menge.push_back(i);     // hinten aufsteigend
    }

    /* Mengen ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* die ersten 3 Elemente einer Sortierung ermitteln
     */
    partial_sort (menge.begin(), menge.begin()+3, menge.end());

    /* Menge wieder ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* die ersten 11 Elemente einer umgekehrten Sortierung ermitteln
     */
    partial_sort (menge.begin(), menge.begin()+11, menge.end(),
                  greater<int>());

    /* Menge wieder ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
