#include <iostream>
#include <cstdlib>
using namespace std;

int main()
{
    char c;

    // Exceptions fuer alle "Fehler"
    cin.exceptions (ios::eofbit | ios::failbit | ios::badbit);
    cout.exceptions (ios::eofbit | ios::failbit | ios::badbit);

    try {
        // solange Zeichen gelesen werden kann
        while (cin.get(c)) {
            // Zeichen ausgeben
            cout.put(c);
        }
    }
    catch (ios::failure error) {
        // EOF nicht als Fehler behandeln
        if (!cin.eof()) {
            if (cin.fail()) {
                cerr << "Lesefehler: " << error.what() << endl;
                exit (EXIT_FAILURE);
            }
            if (cout.fail()) {
                cerr << "Schreibfehler: " << error.what() << endl;
                exit (EXIT_FAILURE);
            }
        }
    }
}
